#include "stdafx.h"
#include "CraftVisitor.h"


void CraftComplianceVisitor::visit(Car& car)
{
	PrintIndents();
	std::cout << "visiting a Car" << std::endl;
	compliant &= car.numberOfSeatbelts >= car.numberOfSeats;
}

void CraftComplianceVisitor::visit(Boat& boat)
{
	PrintIndents();
	std::cout << "visiting a Boat" << std::endl;
	compliant &= boat.maxNumberOfPassengers >= boat.numberOfLifeVests;
};

void CraftComplianceVisitor::visit(Plane& p)
{
	PrintIndents();
	std::cout << "visiting a Plane" << std::endl;
	compliant &=  p.numberOfParachutes>= p.numberOfSeats;
};

void CraftComplianceVisitor::visit(AircraftCarrier& ac)
{
	PrintIndents();
	std::cout << "visiting an Aircraft Carrier\t-\t"; 
	visit(static_cast<Boat&>(ac));

	compliant &= ac.maxNumberOfPlanes >= ac.planes->size();

	indentAmmount++;//since we are about to check the children, we are going to indent the output
	for(auto i = ac.planes->begin(); i != ac.planes->end(); i ++)
	{
		visit(**i);
	}
	indentAmmount--;
};