#pragma once
#include "Visitable.h"
#include <vector>
#include "VisitorBase.h"


struct Craft : Visitable
{
	int weight, color;
	virtual void accept(VisitorBase &v){};
};

struct Car : Craft
{
	Car(int numberOfSeats, int numberOfSeatbelts): numberOfSeats(numberOfSeats), numberOfSeatbelts(numberOfSeatbelts){};
	int numberOfSeats, numberOfSeatbelts;
	virtual void accept(VisitorBase &v);
};

struct Plane : Craft
{
	Plane(int numberOfSeats, int numberOfParachutes): numberOfSeats(numberOfSeats), numberOfParachutes(numberOfParachutes){};
	int numberOfSeats, numberOfParachutes;
	virtual void accept(VisitorBase &v);
};

struct Boat : Craft
{
	Boat(int numberOfLifeVests, int maxNumberOfPassengers): numberOfLifeVests(numberOfLifeVests), maxNumberOfPassengers(maxNumberOfPassengers){};
	int numberOfLifeVests, maxNumberOfPassengers;
	virtual void accept(VisitorBase &v);

};

struct AircraftCarrier : Boat
{
	AircraftCarrier(int maxNumberOfPlanes, std::vector<Plane*>* planes) : Boat(50,50), maxNumberOfPlanes(maxNumberOfPlanes), planes(planes){};
	std::vector<Plane*>* planes;
	int maxNumberOfPlanes;
	virtual void accept(VisitorBase &v);
};
