// Visitor.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include "Crafts.h"
#include "CraftVisitor.h"



int _tmain(int argc, _TCHAR* argv[])
{
	std::vector<Visitable*> crafts;
	crafts.push_back(new Boat(1,1));
	crafts.push_back(new Plane(1,1));
	crafts.push_back(new Car(1,1));

	auto planesOnAircraftCarrier = new std::vector<Plane*>();
	planesOnAircraftCarrier->push_back(new Plane(1,1));
	planesOnAircraftCarrier->push_back(new Plane(1,1));
	planesOnAircraftCarrier->push_back(new Plane(1,1));

	crafts.push_back(new AircraftCarrier(3, planesOnAircraftCarrier));
	
	CraftComplianceVisitor v;
	for(auto i = crafts.begin(); i != crafts.end(); i++)
	{
		(*i)->accept(v);
	}
	
	std::cout << "\nthe crafts are " << (!v.compliant ? "not " : "") << "compliant." << std::endl;

	return 0;
};

